module cantor2 where

  data Empty : Set where

  data One : Set where
    one : One

  data coprod (A : Set1) (B : Set1) : Set1 where
    inl : ∀ (a : A) -> coprod A B
    inr : ∀ (b : B) -> coprod A B

  postulate exmid : ∀ (A : Set1) -> coprod A (A -> Empty)

  data Eq1 {A : Set1} (x : A) : A -> Set1 where
    refleq1 : Eq1 x x

  data I : (Set -> Set) -> Set where

  data invimageI (a : Set) : Set1 where
    invelmtI : forall x -> (Eq1 (I x) a) -> invimageI a

  cantor : Set -> Set
  cantor a with exmid (invimageI a)
  cantor .(I x) | inl (invelmtI x refleq1) = x (I x) -> Empty
  cantor a | inr b = One

  CANTOR : Set
  CANTOR = I cantor

  yes : cantor CANTOR
  yes with exmid (invimageI CANTOR)
  yes | inl (invelmtI .cantor refleq1) = λ p -> p p
  yes | inr b = one

  no : cantor CANTOR -> Empty
  no p with exmid (invimageI CANTOR)
  no p | inl (invelmtI .cantor refleq1) = p p
  no p | inr b with b (invelmtI cantor refleq1)
  no p | inr b | ()

  Ω : Empty
  Ω = no yes
